#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <wchar.h>
#include <locale.h>
#include <unistd.h>
#include "tp3.h"

/* Exercice 3 */

// 1
/* les variables a et b sont locales à la fonction,
   leurs modifications ne se repercutent donc pas
   en dehors de la fonction. */

// 2
void echange(int *a, int *b)
{
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

// 3
void affiche_entiers(int *tab, int n)
{
  int i;
  for (i = 0; i < n; i++)
  {
    printf("%d ", tab[i]);
  }
  printf("\n");
}

// 4
void affiche_floats(float *tab, int n)
{
  int i;
  for (i = 0; i < n; i++)
  {
    printf("%f ", tab[i]);
  }
  printf("\n");
}

/* Exercice 4 */

// 1
int *copie(int *tab, int n)
{
  int *cp = (int*)malloc(n * sizeof(int));
  int i;
  for (i = 0; i < n; i++)
  {
    cp[i] = tab[i];
  }
  return cp;
}

/* Exercice 5 */
float *premiers_termes(float u0, float a, float b, int n)
{
  float *u = (float *)malloc(n * sizeof(float));
  u[0] = u0;
  for (int i = 1; i < n; i++)
  {
    u[i] = a * u[i-1] + b;
  }
  return u;
}

/* Exercice 6 */
bool *eratosthene(int n)
{
  bool *premier = (bool *)malloc((n+1) * sizeof(bool));

  // Initialisation
  premier[0] = false;
  premier[1] = false;
  for (int i = 2; i < n+1; i++)
  {
    premier[i] = true;
  }

  // Crible
  for (int i = 2; i < n+1; i++)
  {
    if (premier[i])
    {
      for (int j = 2*i; j <= n; j += i)
      {
        premier[j] = false;
      }
    }
  }
  return premier;
}

/* Exercice 7 */

// 1
int *prochaine_ligne(int *t, int n)
{
  int *next = (int*)malloc((n+2) * sizeof(int));

  next[0] = 1;
  next[n+1] = 1;

  for (int i = 1; i <= n; i++)
  {
    next[i] = t[i-1] + t[i];
  }

  return next;
}

// 2
int **triangle_de_pascal(int n)
{
  int **triangle = (int **)malloc(n * sizeof(int*));

  // première ligne
  triangle[0] = (int *)malloc(sizeof(int));
  triangle[0][0] = 1;

  // Calcul du triangle
  for (int i = 0; i < n-1; i++)
  {
    triangle[i+1] = prochaine_ligne(triangle[i],i);
  }

  return triangle;
}

/* Exercice 8 */

int vehicule(int f)
{
  if (rand()%f == 0)
  {
    return 0;
  }
  else
  {
    return (rand()%4) + 1;
  }
}

// 1
int *init(int f, int n)
{
  int *route = (int *)malloc(n * sizeof(int));

  for (int i = 0; i < n; i++)
  {
    route[i] = vehicule(f);
  }

  return route;
}

// 2
int *next(int *route, int n, int f)
{
  int *next_route = copie(route, n);

  for (int i = 1; i < n; i++)
  {
    if (route[i] != 0 && route[i-1] == 0)
    {
      next_route[i] = 0;
      next_route[i-1] = route[i];
    }
  }
  next_route[0] = 0;

  if (route[n-1] == 0)
  {
    next_route[n-1] = vehicule(f);
  }

  return next_route;
}

// 3
void affiche(int *route, int n){
  //le type wint_t est hors programme
  wint_t v[] = {' ',(wint_t)128663, (wint_t)128665, (wint_t)128661, (wint_t)127949};
  //cette instruction est hors programme et permet l'affichage des emojis (voitures)
  setlocale(LC_ALL, "");
  for(int i=0; i<n; i++){
    printf("%lc", v[route[i]]);
    if (route[i] == 0)
    {
      printf("%lc", v[route[i]]);
    }
  }
  printf(" ");
  // instructions également hors programme
  fflush(stdout); // force à mettre à jour la sortie standard
  sleep(1); // Met le programme en pause pendant 1 seconde
  printf("\r"); // revient au début de la ligne
}
